{
  if (meshChanged)
    {
      U.correctBoundaryConditions();

      U.oldTime().correctBoundaryConditions();
      
      forAll(U.boundaryField(), patchI)
        {
      	  if (U.boundaryField()[patchI].fixesValue())
            {
      	      U.boundaryField()[patchI].initEvaluate();
            }
        }

      forAll(U.boundaryField(), patchI)
        {
      	  if (U.boundaryField()[patchI].fixesValue())
            {
      	      U.boundaryField()[patchI].evaluate();

      	      phi.boundaryField()[patchI] =
      		rho.boundaryField()[patchI]*
      		(U.boundaryField()[patchI]
      		& mesh.Sf().boundaryField()[patchI]);
            }
        }
    }

    wordList pcorrTypes
    (
        p.boundaryField().size(),
        zeroGradientFvPatchScalarField::typeName
    );

    forAll(p.boundaryField(), patchI)
    {
        if (p.boundaryField()[patchI].fixesValue())
        {
            pcorrTypes[patchI] = fixedValueFvPatchScalarField::typeName;
        }
    }

    volScalarField pcorr
    (
        IOobject
        (
            "pcorr",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        mesh,
        dimensionedScalar("pcorr", p.dimensions(), 0.0),
        pcorrTypes
    );

  pcorr == p;
  pcorr.oldTime() == p.oldTime();

  tmp<fvVectorMatrix> UEqn
  (
     fvm::ddt(rho, U)
     + fvm::div(phi, U)
     + turbulence->divDevRhoReff(U)
     ==
     rho.dimensionedInternalField()*g
     + parcels.SU(U)
  );
  
  UEqn().relax();

  volScalarField rAU(1.0/UEqn().A());
 
  phi = fvc::interpolate(rho)
    *((fvc::interpolate(U) & mesh.Sf()) - fvc::meshPhi(rho,U)); 

  while(pimple.correctNonOrthogonal())
  {
      fvScalarMatrix pcorrEqn
      (
       fvm::ddt(psi, pcorr)
       + fvc::div(phi) 
       - fvm::laplacian(rho*rAU, pcorr)
      );
      
      pcorrEqn.solve();
      
      if (pimple.finalNonOrthogonalIter())
      {
	phi += pcorrEqn.flux(); 
      }
  }
}
